
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class SuppliersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const suppliers = await db.suppliers.create(
            {
                id: data.id || undefined,
        
        supplier_number: data.supplier_number
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        email: data.email
        ||
        null
            ,
            
        phone: data.phone
        ||
        null
            ,
            
        tax_number: data.tax_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await suppliers.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await suppliers.setBilling_address( data.billing_address || null, {
            transaction,
        });
        
        await suppliers.setShipping_address( data.shipping_address || null, {
            transaction,
        });
        
        await suppliers.setPayment_term( data.payment_term || null, {
            transaction,
        });
        

        

        

        return suppliers;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const suppliersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                supplier_number: item.supplier_number
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                email: item.email
            ||
            null
            ,
            
                phone: item.phone
            ||
            null
            ,
            
                tax_number: item.tax_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const suppliers = await db.suppliers.bulkCreate(suppliersData, { transaction });

        // For each item created, replace relation files
        

        return suppliers;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const suppliers = await db.suppliers.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.supplier_number !== undefined) updatePayload.supplier_number = data.supplier_number;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.email !== undefined) updatePayload.email = data.email;
        
        
        if (data.phone !== undefined) updatePayload.phone = data.phone;
        
        
        if (data.tax_number !== undefined) updatePayload.tax_number = data.tax_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await suppliers.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await suppliers.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.billing_address !== undefined) {
            await suppliers.setBilling_address(
              
              data.billing_address,
              
              { transaction }
            );
        }
        
        if (data.shipping_address !== undefined) {
            await suppliers.setShipping_address(
              
              data.shipping_address,
              
              { transaction }
            );
        }
        
        if (data.payment_term !== undefined) {
            await suppliers.setPayment_term(
              
              data.payment_term,
              
              { transaction }
            );
        }
        

        
        

        

        return suppliers;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const suppliers = await db.suppliers.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of suppliers) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of suppliers) {
                await record.destroy({transaction});
            }
        });


        return suppliers;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const suppliers = await db.suppliers.findByPk(id, options);

        await suppliers.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await suppliers.destroy({
            transaction
        });

        return suppliers;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const suppliers = await db.suppliers.findOne(
            { where },
            { transaction },
        );

        if (!suppliers) {
            return suppliers;
        }

        const output = suppliers.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.purchase_orders_supplier = await suppliers.getPurchase_orders_supplier({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await suppliers.getOrganization({
            transaction
        });
        
        
        output.billing_address = await suppliers.getBilling_address({
            transaction
        });
        
        
        output.shipping_address = await suppliers.getShipping_address({
            transaction
        });
        
        
        output.payment_term = await suppliers.getPayment_term({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.addresses,
        as: 'billing_address',
        
        where: filter.billing_address ? {
          [Op.or]: [
            { id: { [Op.in]: filter.billing_address.split('|').map(term => Utils.uuid(term)) } },
            {
              label: {
                [Op.or]: filter.billing_address.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.addresses,
        as: 'shipping_address',
        
        where: filter.shipping_address ? {
          [Op.or]: [
            { id: { [Op.in]: filter.shipping_address.split('|').map(term => Utils.uuid(term)) } },
            {
              label: {
                [Op.or]: filter.shipping_address.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.payment_terms,
        as: 'payment_term',
        
        where: filter.payment_term ? {
          [Op.or]: [
            { id: { [Op.in]: filter.payment_term.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.payment_term.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.supplier_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'suppliers',
                        'supplier_number',
                        filter.supplier_number,
                    ),
                };
            }
            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'suppliers',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.email) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'suppliers',
                        'email',
                        filter.email,
                    ),
                };
            }
            
            if (filter.phone) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'suppliers',
                        'phone',
                        filter.phone,
                    ),
                };
            }
            
            if (filter.tax_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'suppliers',
                        'tax_number',
                        filter.tax_number,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'suppliers',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.suppliers.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'suppliers',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.suppliers.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

